/**
 * Copyright Dave Cline
 * Do not distribute
 */
class HighHatController
{
  public: 
    static const int HIGH_HAT_PEDAL_PIN = 5;  //Digital pin to check for the high hat's foot pedal value (closed or open)
    static const int HIGH_HAT_ANALOG_PIN = 1; //Analog pin to check for strikes to the high hat cymbal
    const int HIGH_HAT_CLOSED_VALUE = 1; 
    int isHighHatClosed;

    HighHatController();
    int tick();
    void closeHighHat();
    void openHighHat();
};


HighHatController::HighHatController() 
{
  isHighHatClosed = 0;
}

void HighHatController::closeHighHat()
{ 
  isHighHatClosed = 1;
}

void HighHatController::openHighHat()
{
  isHighHatClosed = 0;
}

int HighHatController::tick() 
{
  int highHatValue = digitalRead(HIGH_HAT_PEDAL_PIN);
  int justNowClosed = 0;

  if(highHatValue == HIGH_HAT_CLOSED_VALUE && !isHighHatClosed)
  {
    if(DEBUG_MAIN_LOOP)
    {
      Serial.println("Closing high hat");
    }
    justNowClosed = 1;
    closeHighHat();
  } else if(highHatValue != HIGH_HAT_CLOSED_VALUE && isHighHatClosed) {
    if(DEBUG_MAIN_LOOP)
    {
      Serial.println("Opening high hat");
    }
    openHighHat();  
  }

  return justNowClosed;
}
